var gulp = require('gulp');
var glob = require('glob');
var path = require('path');
var fs   = require('fs');

gulp.task('collect:js', function (done) {
    var files = glob.sync('src/ext/*/components/register.js');
    var lines = [
        '/**',
        ' * This file is generated by gulp collect:js task, do not edit',
        ' */'
    ];

    files.forEach(function (file) {
        lines.push('require(\'.' + path.sep + path.relative('src/ext', file) + '\');');
    });

    fs.writeFile('src/ext/collected.js', lines.join('\n'), function (err) {
        if (err) {
            throw err;
        }
    });

    done();
});


gulp.task('collect:styl', function (done) {
    var files = glob.sync('src/ext/*/styl/index.styl');
    var lines = [
        '/**',
        ' * This file is generated by gulp collect:styl task, do not edit',
        ' */'
    ];

    files.forEach(function (file) {
        lines.push('@import "' + path.relative('src/ext', file) + '";');
    });

    fs.writeFile('src/ext/collected.styl', lines.join('\n'), function (err) {
        if (err) {
            throw err;
        }
    });

    done();
});